;==============================
; タイトル画面
;==============================

; すべてのメッセージレイヤの初期化
[cm]
; スキップを止める
[skipstop]
; オートを止める
[iscript]
 TG.stat.is_auto = false;
 TG.stat.is_wait_auto = false;
[endscript]

; スタックの消去
[clearstack]
; タイトル画面背景
[bg time=2000 storage ="topback.jpg"]
; タイトル画面BGM
[playbgm storage=op.ogg loop=true]
[wait time=200]

*start 

; タイトルボタン（枠外に配置）
[button x=1000 y=0   name="start"   graphic="title/tstart.png"   target="gamestart"]
[button x=1000 y=108 name="load"    graphic="title/tload.png"    target="load"]
[button x=1000 y=216 name="gallery" graphic="title/tgallery.png" target="gallery"]
[button x=1000 y=324 name="config"  graphic="title/tcon.png"     target="config"]
[button x=1000 y=432 name="exit"    graphic="title/texit.png"    target="exit"]


; タイトルボタンを表示する
[show_title_button]

*sound_botton_switch

[iscript]
if(TG.config.defaultBgmVolume == 0 && TG.config.defaultSeVolume == 0) {
  tf.SOUND = 'OFF';
} else {
  tf.SOUND = 'ON';
}
[endscript]

[button x=1000 y=515 name="button_off" graphic="sound_off.png" target="SOUND_ON"]
[button x=1000 y=515 name="button_on"  graphic="sound_on.png"  target="SOUND_OFF"]

; 音声出力の切り替え
[if exp="tf.SOUND=='OFF'"]
  [anim name="button_off" left=700 time=0]
[else]
  [anim name="button_on" left=700 time=0]
[endif]

*bonus

; 特典ボタン表示判定
[iscript]
  tf.bonus_flg = false;
  ; すべてがFになる
  if(sf.clear_flg == 0xFFFF) {
    tf.bonus_flg = true;
  }
[endscript]

[if exp="tf.bonus_flg == true"]
  ; 特典ボタン
  [button x=360 y=70 name="site"    graphic="bonus.png"    target="site"]
[endif]

[s]

;------------ 音声出力の切り替え
*SOUND_ON
[anim name="button_off" left=1000 time=0]
[eval exp="tf.SOUND='ON'"]
[bgmopt volume=50]
[seopt volume=50]
[jump target="sound_botton_switch"]

*SOUND_OFF
[anim name="button_on" left=1000 time=0]
[eval exp="tf.SOUND='OFF'"]
[bgmopt volume=0]
[seopt volume=0]
[jump target="sound_botton_switch"]

;------------ 最初のシナリオへ
*gamestart
[hide_title_button]
[fadeoutbgm time=1000]
[jump storage="name.ks" target="start"]

;------------ ロード画面へ
*load
[hide_title_button]
[showload]
[jump target="start"]

;------------ ギャラリー画面へ
*gallery
[hide_title_button]
[fadeoutbgm time=1000]
[jump storage="cg.ks"]

;------------ コンフィグ画面へ
*config
[hide_title_button]
[showconfig]
[jump target="start"]

;------------ 終了
*exit
[hide_title_button]
[close]
[jump target="start"]

;------------ サイトへ
*site
[iscript]
window.open("http://cloche.rgr.jp/706120.html", "_blank");
[endscript]
[jump target=*bonus]

