tyrano.plugin.kag = {
  tyrano : null,
  kag : null,
  sound_swf : null,
  is_rider : false,
  cache_html : {},
  config : {
    defaultStorageExtension : "jpg",
    projectID : "tyranoproject",
    preload : "on",
    skipSpeed : "30",
    mediaFormatDefault : "ogg",
    configSave : "webstorage"
  },
  define : {
    TYRANO_ENGINE_VERSION : 400,
    "BASE_DIV_NAME" : "tyrano_base",
    FLAG_APRI : false,
    "www" : ""
  },
  options : {
    modules : ["parser", "tag", "layer", "menu", "tag_audio", "tag_system", "tag_ext", "key_mouse", "event", "rider", "tag_camera"]
  },
  variable : {
    sf : {},
    tf : {}
  },
  tmp : {
    checking_macro : false,
    num_anim : 0,
    map_bgm : {},
    map_se : {},
    sleep_game : null,
    base_scale : 1,
    is_se_play : false,
    is_se_play_wait : false,
    is_bgm_play : false,
    is_bgm_play_wait : false,
    video_playing : false
  },
  stat : {
    map_label : {},
    map_macro : {},
    vertical : "false",
    f : {},
    mp : {},
    current_layer : "message0",
    current_page : "fore",
    is_stop : false,
    is_strong_stop : false,
    strong_stop_recover_index : 0,
    is_nowait : false,
    current_message_str : "\u30b2\u30fc\u30e0\u30b9\u30bf\u30fc\u30c8",
    current_page_str : "",
    current_keyframe : "",
    map_keyframe : {},
    is_script : false,
    buff_script : "",
    is_html : false,
    map_html : {},
    stack : {
      "if" : [],
      "call" : [],
      "macro" : []
    },
    set_text_span : false,
    current_scenario : "first.ks",
    is_skip : {},
    is_auto : {},
    current_bgm : "",
    current_bgmovie : {
      storage : "",
      volume : ""
    },
    current_camera : {},
    current_camera_layer : "",
    is_move_camera : false,
    is_wait_camera : false,
    current_line : 0,
    is_hide_message : false,
    is_click_text : false,
    is_adding_text : false,
    flag_ref_page : false,
    ruby_str : "",
    ch_speed : "",
    skip_link : "true",
    flag_glyph : "false",
    current_cursor : "auto",
    font : {
      enable : false,
      color : "",
      bold : "",
      size : "",
      face : "",
      italic : ""
    },
    locate : {
      x : 0,
      y : 0
    },
    default_font : {
      color : "",
      bold : "",
      size : "",
      face : "",
      italic : ""
    },
    chara_pos_mode : "true",
    chara_effect : "swing",
    chara_ptext : "",
    chara_time : "600",
    chara_memory : "false",
    chara_anim : "true",
    pos_change_time : "600",
    chara_talk_focus : "none",
    chara_brightness_value : "60",
    chara_blur_value : "2",
    apply_filter_str : "",
    video_stack : null,
    is_wait_bgmovie : false,
    charas : {},
    play_bgm : true,
    play_se : true,
    buff_label_name : "",
    already_read : false,
    visible_menu_button : false,
    title : ""
  },
  /**
   * @return {undefined}
   */
  init : function() {
    this.kag = this;
    var that = this;
    this.tyrano.test();
    this.parser.loadConfig(function(map_config) {
      that.config = $.extend(true, that.config, map_config);
      that.init_game();
    });
    $("script").each(function() {
      if ($(this).attr("src")) {
        if ($(this).attr("src").indexOf("cordova") != -1 || $(this).attr("src").indexOf("phonegap") != -1) {
          /** @type {boolean} */
          that.define.FLAG_APRI = true;
        }
      }
    });
    try {
      var browser = $.getBrowser();
    } catch (fmt) {
      console.log(fmt);
    }
  },
  /**
   * @param {?} s
   * @return {undefined}
   */
  evalScript : function(s) {
    var TG = this;
    var f = this.stat.f;
    var sf = this.variable.sf;
    var tf = this.variable.tf;
    var mp = this.stat.mp;
    eval(s);
    this.saveSystemVariable();
    if (this.kag.is_rider) {
      this.kag.rider.pushVariableGrid();
    }
  },
  /**
   * @param {?} condition
   * @param {?} preexp
   * @return {?}
   */
  embScript : function(condition, preexp) {
    var f = this.stat.f;
    var sf = this.variable.sf;
    var tf = this.variable.tf;
    var mp = this.stat.mp;
    return eval(condition);
  },
  /**
   * @return {undefined}
   */
  saveSystemVariable : function() {
    $.setStorage(this.kag.config.projectID + "_sf", this.variable.sf);
  },
  /**
   * @return {undefined}
   */
  clearVariable : function() {
    this.stat.f = {};
    this.variable.sf = {};
    this.variable.tf = {};
    this.saveSystemVariable();
  },
  /**
   * @param {?} name
   * @param {?} item
   * @return {undefined}
   */
  pushStack : function(name, item) {
    this.stat.stack[name].push(item);
  },
  /**
   * @param {string} name
   * @return {?}
   */
  popStack : function(name) {
    return this.stat.stack[name].pop();
  },
  /**
   * @param {string} name
   * @return {?}
   */
  getStack : function(name) {
    return this.stat.stack[name][this.stat.stack[name].length - 1];
  },
  /**
   * @param {?} name
   * @param {?} aValue
   * @return {undefined}
   */
  setStack : function(name, aValue) {
    this.stat.stack[name][this.stat.stack[name].length - 1] = aValue;
  },
  /**
   * @return {?}
   */
  endStorage : function() {
    var pm = this.kag.getStack("call");
    if (pm == null) {
      return false;
    }
    this.kag.ftag.nextOrderWithIndex(pm.index, pm.storage);
    this.kag.popStack("call");
  },
  /**
   * @return {undefined}
   */
  init_game : function() {
    var that = this;
    this.parser = object(tyrano.plugin.kag.parser);
    this.parser.kag = that;
    this.ftag = object(tyrano.plugin.kag.ftag);
    this.ftag.kag = that;
    this.ftag.init();
    this.layer = object(tyrano.plugin.kag.layer);
    this.layer.kag = that;
    this.layer.init();
    this.menu = object(tyrano.plugin.kag.menu);
    this.menu.kag = that;
    this.menu.init();
    this.key_mouse = object(tyrano.plugin.kag.key_mouse);
    this.key_mouse.kag = that;
    this.key_mouse.init();
    this.event = object(tyrano.plugin.kag.event);
    this.event.kag = that;
    this.event.init();
    this.rider = object(tyrano.plugin.kag.rider);
    this.rider.kag = that;
    this.rider.init();
    var tmpsf = $.getStorage(this.kag.config.projectID + "_sf");
    if (tmpsf == null) {
      this.variable.sf = {};
    } else {
      /** @type {*} */
      this.variable.sf = eval("(" + tmpsf + ")");
    }
    if (typeof that.variable.sf._system_config_bgm_volume !== "undefined") {
      /** @type {string} */
      that.config["defaultBgmVolume"] = String(that.variable.sf._system_config_bgm_volume);
    }
    if (typeof that.variable.sf._system_config_se_volume !== "undefined") {
      /** @type {string} */
      that.config["defaultSeVolume"] = String(that.variable.sf._system_config_se_volume);
    }
    if (that.variable.sf._config_ch_speed !== undefined) {
      that.config["chSpeed"] = that.variable.sf._config_ch_speed;
    }
    if (that.variable.sf._system_config_auto_speed !== undefined) {
      that.config["autoSpeed"] = that.variable.sf._system_config_auto_speed;
    }
    if (that.variable.sf._system_config_auto_click) {
      that.config["autoClickStop"] = that.variable.sf._system_config_auto_click_stop;
    }
    if (that.variable.sf._config_already_speed !== undefined) {
      that.config["alreadySpeed"] = that.variable.sf._config_already_speed;
    }
    if (that.variable.sf._system_config_already_read_text_color) {
      that.config["alreadyReadTextColor"] = that.variable.sf._system_config_already_read_text_color;
    }
    if (that.variable.sf._system_config_unread_text_skip) {
      that.config["unReadTextSkip"] = that.variable.sf._system_config_unread_text_skip;
    }
    if (that.variable.sf.message_window_type) {
      that.config["messageWindowType"] = that.variable.sf.message_window_type;
    }
    var auto_save_data = $.getStorage(this.kag.config.projectID + "_tyrano_auto_save");
    this.variable.sf["system"] = {};
    if (auto_save_data) {
      /** @type {boolean} */
      this.variable.sf["system"]["autosave"] = true;
    } else {
      /** @type {boolean} */
      this.variable.sf["system"]["autosave"] = false;
    }
    this.variable.tf["system"] = {};
    /** @type {Array} */
    this.variable.tf["system"]["backlog"] = [];
    var button_menu_obj = $("<div class='button_menu' style='z-index:100000000'><img src='./tyrano/images/kag/" + $.novel("file_button_menu") + "'  /></div>");
    if (this.kag.config.configLeft != "-1" && this.kag.config.configTop != "-1") {
      button_menu_obj.css("left", parseInt(this.kag.config.configLeft));
      button_menu_obj.css("top", parseInt(this.kag.config.configTop));
    } else {
      button_menu_obj.css("left", this.config.scWidth - 35);
      button_menu_obj.css("top", this.config.scHeight - 35);
    }
    button_menu_obj.click(function() {
      that.menu.showMenu();
    });
    if (this.kag.config.configVisible == "false") {
      button_menu_obj.hide();
      /** @type {boolean} */
      this.kag.stat.visible_menu_button = false;
    } else {
      /** @type {boolean} */
      this.kag.stat.visible_menu_button = true;
    }
    $("." + this.kag.define.BASE_DIV_NAME).append(button_menu_obj);
    if (this.kag.config["useCamera"] && this.kag.config["useCamera"] == "true") {
      /** @type {string} */
      this.kag.config["ScreenCentering"] = "false";
    }
    if (this.kag.config["ScreenCentering"] && this.kag.config["ScreenCentering"] == "false") {
      $(".tyrano_base").css("transform-origin", "0 0");
      $(".tyrano_base").css({
        margin : 0
      });
    } else {
      $(".tyrano_base").css("transform-origin", "50 50");
    }
    this.tyrano.base.setBaseSize(this.config.scWidth, this.config.scHeight);
    this.tyrano.base.fitBaseSize(that.config.scWidth, that.config.scHeight);
    $(window).bind("load orientationchange resize", function() {
      if (Math.abs(window.orientation) === 90) {
        if (window.pageYOffset === 0) {
          window.scrollTo(0, 1);
        }
        that.tyrano.base.fitBaseSize(that.config.scWidth, that.config.scHeight);
      } else {
        if (window.pageYOffset === 0) {
          window.scrollTo(0, 1);
        }
        that.tyrano.base.fitBaseSize(that.config.scWidth, that.config.scHeight);
      }
    });
    this.layer.addLayer("base");
    this.layer.addLayer("message0");
    var j_message = $("<div class='message_outer'></div>");
    j_message.css("background-color", $.convertColor(this.config.frameColor)).css("opacity", $.convertOpacity(this.config.frameOpacity)).css("left", eval(this.config.ml)).css("top", eval(this.config.mt)).css("width", eval(this.config.mw)).css("height", eval(this.config.mh)).css("z-index", 100);
    j_message.l_visible;
    this.layer.appendObj("message0", "fore", j_message);
    var j_message_inner = $("<div class='message_inner' style='z-index:1001'></div>");
    if (this.config.WordBreak == "false") {
      j_message_inner.css("word-break", "break-all");
    }
    this.layer.appendObj("message0", "fore", j_message_inner);
    /** @type {number} */
    var numGuis = parseInt(this.config.numMessageLayers);
    /** @type {number} */
    var i = 1;
    for (;i < numGuis;i++) {
      /** @type {string} */
      var message_layer_name = "message" + i;
      this.layer.addLayer(message_layer_name);
      this.layer.getLayer(message_layer_name).attr("l_visible", "false");
      this.layer.getLayer(message_layer_name).hide();
      var j_message1 = j_message.clone(false);
      this.layer.appendObj(message_layer_name, "fore", j_message1);
      var j_message_inner1 = j_message_inner.clone(false);
      this.layer.appendObj(message_layer_name, "fore", j_message_inner1);
    }
    this.layer.refMessageLayer();
    /** @type {number} */
    var precision = parseInt(this.config.numCharacterLayers);
    /** @type {number} */
    i = 0;
    for (;i < precision;i++) {
      this.layer.addLayer("" + i);
      this.layer.getLayer("" + i, "fore").css("display", "none").css("z-index", 10);
    }
    this.stat.default_font.color = $.convertColor(this.kag.config.defaultChColor);
    this.stat.default_font.bold = $.convertBold(this.kag.config.defaultBold);
    this.stat.default_font.size = this.kag.config.defaultFontSize;
    this.stat.default_font.face = this.kag.config.userFace;
    this.stat.vertical = this.kag.config.vertical;
    this.kag.stat.font = $.extend(true, $.cloneObject(this.kag.stat.font), this.stat.default_font);
    this.setTitle(this.config["System.title"]);
    this.setCursor(this.config["cursorDefault"]);
    /** @type {string} */
    var first_scenario_file = "first.ks";
    if ($("#first_scenario_file").size() > 0) {
      first_scenario_file = $("#first_scenario_file").val();
    }
    this.loadScenario(first_scenario_file, function(array_tag) {
      that.ftag.buildTag(array_tag);
    });
    that.rider.complete(this);
  },
  /**
   * @param {?} spaceName
   * @return {undefined}
   */
  pushBackLog : function(spaceName) {
    /** @type {number} */
    var g = parseInt(this.kag.config["maxBackLogNum"]);
    if (g < 1) {
      return;
    }
    this.variable.tf["system"]["backlog"].push(spaceName);
    if (g < this.variable.tf["system"]["backlog"].length) {
      this.variable.tf["system"]["backlog"].shift();
    }
  },
  /**
   * @param {string} title
   * @return {undefined}
   */
  setTitle : function(title) {
    /** @type {string} */
    this.stat.title = title;
    /** @type {string} */
    document.title = title;
  },
  /**
   * @return {undefined}
   */
  pushAnimStack : function() {
    this.kag.tmp.num_anim++;
  },
  /**
   * @param {string} name
   * @return {undefined}
   */
  setCursor : function(name) {
    /** @type {string} */
    this.stat.current_cursor = name;
    if (name === "default") {
      $("body").css("cursor", "auto");
    } else {
      $("body").css("cursor", "url(./data/image/" + name + "),default");
    }
  },
  /**
   * @return {undefined}
   */
  popAnimStack : function() {
    if (this.kag.tmp.num_anim > 0) {
      this.kag.tmp.num_anim--;
    }
    if (this.kag.tmp.num_anim <= 0) {
      if (this.kag.stat.is_stop == true) {
        this.kag.layer.showEventLayer();
        this.kag.ftag.nextOrder();
      }
    }
  },
  /**
   * @param {string} file_name
   * @param {Function} call_back
   * @return {undefined}
   */
  loadScenario : function(file_name, call_back) {
    var that = this;
    /** @type {boolean} */
    this.stat.is_strong_stop = true;
    /** @type {string} */
    this.stat.current_scenario = file_name;
    /** @type {string} */
    var file_url = "";
    if ($.isHTTP(file_name)) {
      /** @type {string} */
      file_url = file_name;
    } else {
      /** @type {string} */
      file_url = "./data/scenario/" + file_name;
    }
    $.loadText(file_url, function(text_str) {
      var result_obj = that.parser.parseScenario(text_str);
      var tag_obj = result_obj.array_s;
      var map_label = result_obj.map_label;
      that.stat.map_label = map_label;
      /** @type {boolean} */
      that.stat.is_strong_stop = false;
      if (call_back) {
        call_back(tag_obj);
      }
    });
  },
  /**
   * @return {?}
   */
  getMessageInnerLayer : function() {
    return this.layer.getLayer(this.stat.current_layer, this.stat.current_page).find(".message_inner");
  },
  /**
   * @return {?}
   */
  getMessageOuterLayer : function() {
    return this.layer.getLayer(this.stat.current_layer, this.stat.current_page).find(".message_outer");
  },
  /**
   * @return {?}
   */
  getMessageCurrentSpan : function() {
    var j_obj = this.layer.getLayer(this.stat.current_layer, this.stat.current_page).find(".message_inner").find("p").find(".current_span");
    return j_obj;
  },
  /**
   * @return {?}
   */
  setMessageCurrentSpan : function() {
    var jtext = this.getMessageInnerLayer();
    if (jtext.find("p").length == 0) {
      if (this.stat.vertical == "true") {
        jtext.append($("<p class='vertical_text'></p>"));
      } else {
        jtext.append($("<p class=''></p>"));
      }
    }
    if (jtext.find("p").find(".current_span").length > 0) {
      jtext.find("p").find(".current_span").removeClass("current_span");
      /** @type {boolean} */
      this.stat.set_text_span = false;
    }
    var j_span = $("<span class='current_span'></span>");
    jtext.find("p").append(j_span);
    return j_span;
  },
  /**
   * @param {Object} jtext
   * @return {undefined}
   */
  checkMessage : function(jtext) {
    if (this.stat.set_text_span == true) {
      jtext.find("p").find(".current_span").removeClass("current_span");
      /** @type {boolean} */
      this.stat.set_text_span = false;
    }
    if (jtext.find(".current_span").length == 0) {
      jtext.find("p").append($("<span class='current_span'></span>"));
    }
  },
  /**
   * @param {Object} jtext
   * @param {string} str
   * @return {undefined}
   */
  appendMessage : function(jtext, str) {
    jtext.find("p").find(".current_span").html(str);
  },
  /**
   * @param {string} src
   * @param {?} callback
   * @return {undefined}
   */
  preload : function(src, callback) {
    var that = this;
    $("<img />").attr("src", src).load(function(dataAndEvents) {
      if (callback) {
        callback();
      }
    }).error(function(dataAndEvents) {
      that.kag.error("\u753b\u50cf\u30d5\u30a1\u30a4\u30eb\u300c" + src + "\u300d\u304c\u898b\u3064\u304b\u308a\u307e\u305b\u3093\u3002\u5834\u6240\u306f\u30d5\u30eb\u30d1\u30b9\u3067\u6307\u5b9a\u3055\u308c\u3066\u3044\u307e\u3059\u304b\uff1f (\u4f8b)data/fgimage/file.png");
      if (callback) {
        callback();
      }
    });
  },
  /**
   * @param {Object} element
   * @param {Object} options
   * @return {?}
   */
  setStyles : function(element, options) {
    for (key in options) {
      if (options[key]) {
        if (options[key] == "") {
        } else {
          element.css(key, options[key]);
        }
      }
    }
    return element;
  },
  /**
   * @param {string} name
   * @param {Object} content
   * @param {?} callback
   * @return {undefined}
   */
  html : function(name, content, callback) {
    var elem = this;
    content = content || {};
    if (this.cache_html[name]) {
      if (callback) {
        var that = $.templates(this.cache_html[name]);
        var items = that.render(content);
        callback($(items));
      }
    } else {
      $.loadText("./tyrano/html/" + name + ".html", function(i) {
        var c = $.templates(i);
        var items = c.render(content);
        elem.cache_html[name] = i;
        if (callback) {
          callback($(items));
        }
      });
    }
  },
  /**
   * @param {string} str
   * @return {undefined}
   */
  error : function(str) {
    if (this.kag.config["debugMenu.visible"] == "true") {
      var current_storage = this.kag.stat.current_scenario;
      /** @type {number} */
      var line = parseInt(this.kag.stat.current_line) + 1;
      /** @type {string} */
      var msgs = "Error:" + current_storage + ":" + line + "\u884c\u76ee:" + str;
      $.error_message(msgs);
    }
  },
  /**
   * @param {?} error
   * @return {undefined}
   */
  warning : function(error) {
    if (this.kag.config["debugMenu.visible"] == "true") {
      alert(error);
    }
  },
  /**
   * @param {?} fmt
   * @return {undefined}
   */
  log : function(fmt) {
    if (this.kag.config["debugMenu.visible"] == "true") {
      console.log(fmt);
    }
  },
  /**
   * @return {undefined}
   */
  test : function() {
  }
};
tyrano.plugin.kag.tag = {};
