tyrano.plugin.kag.menu = {
  tyrano : null,
  kag : null,
  snap : null,
  /**
   * @return {undefined}
   */
  init : function() {
  },
  /**
   * @param {?} x
   * @return {?}
   */
  showMenu : function(x) {
    if (this.kag.layer.layer_event.css("display") == "none" && this.kag.stat.is_strong_stop != true) {
      return false;
    }
    var that = this;
    /** @type {boolean} */
    this.kag.stat.is_skip = false;
    /** @type {boolean} */
    this.kag.stat.is_auto = false;
    /** @type {boolean} */
    this.kag.stat.is_auto_wait = false;
    var elm = this.kag.layer.getMenuLayer();
    elm.empty();
    this.kag.html("menu", {
      "novel" : $.novel
    }, function(env) {
      var a = $(env);
      elm.append(a);
      elm.find(".menu_skip").click(function(event) {
        elm.html("");
        elm.hide();
        if (that.kag.stat.visible_menu_button == true) {
          $(".button_menu").show();
        }
        /** @type {boolean} */
        that.kag.stat.is_skip = true;
        if (that.kag.layer.layer_event.css("display") == "none") {
        } else {
          that.kag.ftag.nextOrder();
        }
        event.stopPropagation();
      });
      elm.find(".menu_close").click(function(event) {
        elm.hide();
        if (that.kag.stat.visible_menu_button == true) {
          $(".button_menu").show();
        }
        event.stopPropagation();
      });
      elm.find(".menu_window_close").click(function(event) {
        that.kag.layer.hideMessageLayers();
        elm.hide();
        if (that.kag.stat.visible_menu_button == true) {
          $(".button_menu").show();
        }
        event.stopPropagation();
      });
      elm.find(".menu_save").click(function(event) {
        that.displaySave();
        event.stopPropagation();
      });
      elm.find(".menu_load").click(function(event) {
        that.displayLoad();
        event.stopPropagation();
      });
      elm.find(".menu_config").click(function(event) {
        that.displayConfig();
        event.stopPropagation();
      });
      elm.find(".menu_exit").click(function(event) {
        that.displayExit();
        event.stopPropagation();
      });
      elm.find(".menu_back_title").click(function() {
        if (!confirm($.lang("go_title"))) {
          return false;
        }
        location.reload();
      });
      elm.find(".menu_backlog").click(function(event) {
        that.displayLog();
        event.stopPropagation();
      });
      elm.find(".display_menu").click(function(event) {
        elm.hide();
        if (that.kag.stat.visible_menu_button == true) {
          $(".button_menu").show();
        }
        event.stopPropagation();
      });
      elm.show();
      $(".button_menu").hide();
    });
  },
  /**
   * @return {undefined}
   */
  displaySave : function() {
    var that = this;
    /** @type {boolean} */
    this.kag.stat.is_skip = false;
    var browserEvent = that.getSaveData();
    var codeSegments = browserEvent.data;
    var layer_menu = that.kag.layer.getMenuLayer();
    var data_current_page = 0;
    if(this.kag.variable.sf.data_current_page !== undefined) {
      var data_current_page = this.kag.variable.sf.data_current_page;
    }
    /** @type {number} */
    var tmp_array = new Array;
    var i = 0;
    for (;i < 5; i++) {
      /** @type {number} */
      codeSegments[i + (5 * data_current_page)].num = i;
      tmp_array.push(codeSegments[i + (5 * data_current_page)]);
    }
    this.kag.html("save", {
      array_save : tmp_array,
      "novel" : $.novel
    }, function(ul) {
      var menu = $(ul);
      menu.find(".save_list").css("font-family", that.kag.config.userFace);
      menu.find(".save_display_area").each(function() {
        $(this).click(function(dataAndEvents) {
          var _i = parseInt($(this).attr("data-num")) + (5 * data_current_page);
          var tooltip = that.kag.layer.getMenuLayer();
          var dialog = "<div class='confirm_backimage' style='z-index: 999999;position:absolute;top: 0px;left: 0px; width:100%; height:100%'>";
          var dialog = dialog + "<div style='position:absolute; top: 150px;left: 184px;'><img src='tyrano/images/kag/sback.png' /></div>";
          var dialog = dialog + "<div class='dialog_yes' style='cursor:pointer; position:absolute; top: 250px;left: 270px;'><img src='tyrano/images/kag/yes.png' /></div>";
          var dialog = dialog + "<div class='dialog_no' style='cursor:pointer; position:absolute; top: 250px;left: 420px;'><img src='tyrano/images/kag/no.png' /></div>";
          var dialog = dialog + "</div>";
          var $dialog = $(dialog);
          $dialog.find(".dialog_yes").click(function(e) {
            /** @type {null} */
            that.snap = null;
            that.doSave(_i);
            var $this = that.kag.layer.getMenuLayer();
            $this.hide();
            $this.empty();
            if (that.kag.stat.visible_menu_button == true) {
              $(".button_menu").show();
            }
          });
          $dialog.find(".dialog_no").click(function(e) {
            $dialog.hide();
            $dialog.empty();
          });
          tooltip.append($dialog);
        });
      });
      menu.find(".page_select").each(function() {
        var num = $(this).attr("num");
        if(data_current_page == num) {
          $(this).find("img").attr("src","tyrano/images/kag/botan_on.png");
        } else {
          $(this).find("img").attr("src","tyrano/images/kag/botan_off.png");
        }

        $(this).click(function(e) {
          menu.find(".page_select").each(function() {
            if(num == $(this).attr("num")) {
              $(this).find("img").attr("src","tyrano/images/kag/botan_on.png");
            } else {
              $(this).find("img").attr("src","tyrano/images/kag/botan_off.png");
            }
          });
          data_current_page = $(this).attr("num");
          that.kag.evalScript("sf.data_current_page = " + data_current_page);
          var count = 0;
          menu.find(".save_display_area").each(function() {
            var chapter_name = codeSegments[count + (5 * data_current_page)].chapter_name;
            var date = codeSegments[count + (5 * data_current_page)].save_date;
            var title = codeSegments[count + (5 * data_current_page)].title;
            $(this).find(".save_list_chapter_name").text(chapter_name);
            $(this).find(".save_list_item_date").text(date);
            $(this).find(".save_list_item_text").text(title);
            count++;
          });
        });
      });
      menu.find(".page_yazirusi_l").click(function() {
        if(data_current_page > 0) {
          data_current_page--;
          that.kag.evalScript("sf.data_current_page = " + data_current_page);
          menu.find(".page_select").each(function() {
            if(data_current_page == $(this).attr("num")) {
              $(this).find("img").attr("src","tyrano/images/kag/botan_on.png");
            } else {
              $(this).find("img").attr("src","tyrano/images/kag/botan_off.png");
            }
          });
          var count = 0;
          menu.find(".save_display_area").each(function() {
            var chapter_name = codeSegments[count + (5 * data_current_page)].chapter_name;
            var date = codeSegments[count + (5 * data_current_page)].save_date;
            var title = codeSegments[count + (5 * data_current_page)].title;
            $(this).find(".save_list_chapter_name").text(chapter_name);
            $(this).find(".save_list_item_date").text(date);
            $(this).find(".save_list_item_text").text(title);
            count++;
          });
        }
      });
      menu.find(".page_yazirusi_r").click(function() {
        if(data_current_page < 8) {
          data_current_page++;
          that.kag.evalScript("sf.data_current_page = " + data_current_page);
          menu.find(".page_select").each(function() {
            if(data_current_page == $(this).attr("num")) {
              $(this).find("img").attr("src","tyrano/images/kag/botan_on.png");
            } else {
              $(this).find("img").attr("src","tyrano/images/kag/botan_off.png");
            }
          });
          var count = 0;
          menu.find(".save_display_area").each(function() {
            var chapter_name = codeSegments[count + (5 * data_current_page)].chapter_name;
            var date = codeSegments[count + (5 * data_current_page)].save_date;
            var title = codeSegments[count + (5 * data_current_page)].title;
            $(this).find(".save_list_chapter_name").text(chapter_name);
            $(this).find(".save_list_item_date").text(date);
            $(this).find(".save_list_item_text").text(title);
            count++;
          });
        }
      });
      var layer_menu = that.kag.layer.getMenuLayer();
      that.setMenu(menu);
    });
  },
  /**
   * @param {?} num
   * @return {undefined}
   */
  doSave : function(num) {
    var array_save = this.getSaveData();
    var func = {};
    var that = this;
    if (this.snap == null) {
      this.snapSave(this.kag.stat.current_page_str, function() {
        func = that.snap;
        func.save_date = $.getNowDate() + "\u3000" + $.getNowTime();
        func.chapter_name = that.kag.stat.f.chapter_name;
        array_save.data[num] = func;
        $.setStorage(that.kag.config.projectID + "_tyrano_data", array_save, that.kag.config.configSave);
      });
    }
  },
  /**
   * @return {undefined}
   */
  setQuickSave : function() {
    var that = this;
    var right = that.kag.stat.current_message_str;
    that.kag.menu.snapSave(right, function() {
      var data = that.snap;
      data.save_date = $.getNowDate() + "\u3000" + $.getNowTime();
      $.setStorage(that.kag.config.projectID + "_tyrano_quick_save", data, that.kag.config.configSave);
    });
  },
  /**
   * @return {?}
   */
  loadQuickSave : function() {
    var data = $.getStorage(this.kag.config.projectID + "_tyrano_quick_save", this.kag.config.configSave);
    if (data) {
      /** @type {*} */
      data = eval("(" + data + ")");
    } else {
      return false;
    }
    this.loadGameData($.extend(true, {}, data));
  },
  /**
   * @return {undefined}
   */
  doSetAutoSave : function() {
    var data = this.snap;
    data.save_date = $.getNowDate() + "\u3000" + $.getNowTime();
    $.setStorage(this.kag.config.projectID + "_tyrano_auto_save", data, this.kag.config.configSave);
  },
  /**
   * @return {?}
   */
  loadAutoSave : function() {
    var data = $.getStorage(this.kag.config.projectID + "_tyrano_auto_save", this.kag.config.configSave);
    if (data) {
      /** @type {*} */
      data = eval("(" + data + ")");
    } else {
      return false;
    }
    this.loadGameData($.extend(true, {}, data));
  },
  /**
   * @param {?} title
   * @param {Function} cb
   * @param {string} val
   * @return {undefined}
   */
  snapSave : function(title, cb, val) {
    var that = this;
    /** @type {number} */
    var key = that.kag.ftag.current_order_index - 1;
    var stats = $.extend(true, {}, $.cloneObject(that.kag.stat));
    if (typeof val == "undefined") {
      val = this.kag.config.configThumbnail;
    }
    if (val == "false") {
      /** @type {string} */
      var userid = "";
      var data = {};
      data.title = title;
      data.stat = stats;
      /** @type {number} */
      data.current_order_index = key;
      data.save_date = $.getNowDate() + "\u3000" + $.getNowTime();
      /** @type {string} */
      data.img_data = userid;
      var layer = that.kag.layer.getLayeyHtml();
      data.layer = layer;
      that.snap = $.extend(true, {}, $.cloneObject(data));
      if (cb) {
        cb();
      }
    } else {
      setTimeout(function() {
        html2canvas($("#tyrano_base").get(0), {
          /**
           * @param {Element} canvasObject
           * @return {undefined}
           */
          onrendered : function(canvasObject) {
            var type = canvasObject.toDataURL();
            var data = {};
            data.title = title;
            data.stat = stats;
            /** @type {number} */
            data.current_order_index = key;
            data.save_date = $.getNowDate() + "\u3000" + $.getNowTime();
            data.img_data = type;
            var layer = that.kag.layer.getLayeyHtml();
            data.layer = layer;
            that.snap = $.extend(true, {}, $.cloneObject(data));
            if (cb) {
              cb();
            }
          }
        });
      }, 20);
    }
  },
  /**
   * @return {undefined}
   */
  setGameSleep : function() {
    this.kag.tmp.sleep_game = this.snap;
  },
  /**
   * @return {undefined}
   */
  displayLoad : function() {
    var that = this;
    /** @type {boolean} */
    this.kag.stat.is_skip = false;
    var browserEvent = that.getSaveData();
    var codeSegments = browserEvent.data;
    var layer_menu = that.kag.layer.getMenuLayer();
    var data_current_page = 0;
    if(this.kag.variable.sf.data_current_page !== undefined) {
      var data_current_page = this.kag.variable.sf.data_current_page;
    }
    /** @type {number} */
    var tmp_array = new Array;
    var i = 0;
    for (;i < 5; i++) {
      /** @type {number} */
      codeSegments[i + (5 * data_current_page)].num = i;
      tmp_array.push(codeSegments[i + (5 * data_current_page)]);
    }
    this.kag.html("load", {
      array_save : tmp_array,
      "novel" : $.novel
    }, function(ul) {
      var menu = $(ul);
      menu.find(".save_list").css("font-family", that.kag.config.userFace);
      menu.find(".save_display_area").each(function() {
        $(this).click(function(dataAndEvents) {
          var _i = parseInt($(this).attr("data-num")) + (5 * data_current_page);
          /** @type {null} */
          that.snap = null;
          if(that.loadGame(_i)) {
            var $this = that.kag.layer.getMenuLayer();
            $this.hide();
            $this.empty();
            if (that.kag.stat.visible_menu_button == true) {
              $(".button_menu").show();
            }
          }
        });
      });
      menu.find(".page_select").each(function() {
        var num = $(this).attr("num");
        if(data_current_page == num) {
          $(this).find("img").attr("src","tyrano/images/kag/botan_on.png");
        } else {
          $(this).find("img").attr("src","tyrano/images/kag/botan_off.png");
        }

        $(this).click(function(e) {
          menu.find(".page_select").each(function() {
            if(num == $(this).attr("num")) {
              $(this).find("img").attr("src","tyrano/images/kag/botan_on.png");
            } else {
              $(this).find("img").attr("src","tyrano/images/kag/botan_off.png");
            }
          });
          data_current_page = $(this).attr("num");
          that.kag.evalScript("sf.data_current_page = " + data_current_page);
          var count = 0;
          menu.find(".save_display_area").each(function() {
            var chapter_name = codeSegments[count + (5 * data_current_page)].chapter_name;
            var date = codeSegments[count + (5 * data_current_page)].save_date;
            var title = codeSegments[count + (5 * data_current_page)].title;
            $(this).find(".save_list_chapter_name").text(chapter_name);
            $(this).find(".save_list_item_date").text(date);
            $(this).find(".save_list_item_text").text(title);
            count++;
          });
        });
      });
      menu.find(".page_yazirusi_l").click(function() {
        if(data_current_page > 0) {
          data_current_page--;
          that.kag.evalScript("sf.data_current_page = " + data_current_page);
          menu.find(".page_select").each(function() {
            if(data_current_page == $(this).attr("num")) {
              $(this).find("img").attr("src","tyrano/images/kag/botan_on.png");
            } else {
              $(this).find("img").attr("src","tyrano/images/kag/botan_off.png");
            }
          });
          var count = 0;
          menu.find(".save_display_area").each(function() {
            var chapter_name = codeSegments[count + (5 * data_current_page)].chapter_name;
            var date = codeSegments[count + (5 * data_current_page)].save_date;
            var title = codeSegments[count + (5 * data_current_page)].title;
            $(this).find(".save_list_chapter_name").text(chapter_name);
            $(this).find(".save_list_item_date").text(date);
            $(this).find(".save_list_item_text").text(title);
            count++;
          });
        }
      });
      menu.find(".page_yazirusi_r").click(function() {
        if(data_current_page < 8) {
          data_current_page++;
          that.kag.evalScript("sf.data_current_page = " + data_current_page);
          menu.find(".page_select").each(function() {
            if(data_current_page == $(this).attr("num")) {
              $(this).find("img").attr("src","tyrano/images/kag/botan_on.png");
            } else {
              $(this).find("img").attr("src","tyrano/images/kag/botan_off.png");
            }
          });
          var count = 0;
          menu.find(".save_display_area").each(function() {
            var chapter_name = codeSegments[count + (5 * data_current_page)].chapter_name;
            var date = codeSegments[count + (5 * data_current_page)].save_date;
            var title = codeSegments[count + (5 * data_current_page)].title;
            $(this).find(".save_list_chapter_name").text(chapter_name);
            $(this).find(".save_list_item_date").text(date);
            $(this).find(".save_list_item_text").text(title);
            count++;
          });
        }
      });
      var layer_menu = that.kag.layer.getMenuLayer();
      that.setMenu(menu);
    });
  },
  /**
   * @param {?} num
   * @return {undefined}
   */
  loadGame : function(num) {
    var elem = this.getSaveData();
    var options = elem.data;
    if (options[num].save_date == "") {
      return false;
    }
    this.loadGameData($.extend(true, {}, options[num]));
    return true;
  },
  /**
   * @param {Object} data
   * @return {undefined}
   */
  loadGameData : function(data) {
    /** @type {string} */
    var cursor = "no";
    this.kag.layer.setLayerHtml(data.layer);
    this.kag.stat = data.stat;
    if (this.kag.stat.is_strong_stop == true) {
      /** @type {string} */
      cursor = "stop";
    } else {
      /** @type {boolean} */
      this.kag.stat.is_strong_stop = false;
    }
    this.kag.ftag.startTag("stopbgm", {
      stop : "true"
    });
    this.kag.ftag.startTag("stopse", {
      stop : "true"
    });
    if (this.kag.stat.current_bgm != "") {
      var mstorage = this.kag.stat.current_bgm;
      var pm = {
        loop : "true",
        storage : mstorage,
        stop : "true"
      };
      this.kag.ftag.startTag("playbgm", pm);
    }
    if (!this.kag.stat.current_bgmovie) {
      this.kag.stat.current_bgmovie = {
        storage : "",
        volume : ""
      };
    }
    if (this.kag.config.useCamera == "true") {
      $(".layer_camera").css({
        "-animation-name" : "",
        "-animation-duration" : "",
        "-animation-play-state" : "",
        "-animation-delay" : "",
        "-animation-iteration-count" : "",
        "-animation-direction" : "",
        "-animation-fill-mode" : "",
        "-animation-timing-function" : ""
      });
      for (key in this.kag.stat.current_camera) {
        var state = {
          frames : {
            "0%" : {
              trans : this.kag.stat.current_camera[key]
            },
            "100%" : {
              trans : this.kag.stat.current_camera[key]
            }
          },
          config : {
            duration : "5ms",
            state : "running",
            easing : "ease"
          },
          /**
           * @return {undefined}
           */
          complete : function() {
          }
        };
        if (key == "layer_camera") {
          $(".layer_camera").css("-webkit-transform-origin", "center center");
          $(".layer_camera").a3d(state);
        } else {
          $("." + key + "_fore").css("-webkit-transform-origin", "center center");
          $("." + key + "_fore").a3d(state);
        }
      }
    }
    if (this.kag.stat.current_bgmovie["storage"] != "") {
      $(".tyrano_base").find("video").remove();
      var storage = this.kag.stat.current_bgmovie["storage"];
      var volume = this.kag.stat.current_bgmovie["volume"];
      pm = {
        storage : storage,
        volume : volume,
        stop : "true"
      };
      /** @type {boolean} */
      this.kag.tmp.video_playing = false;
      this.kag.ftag.startTag("bgmovie", pm);
    }
    this.kag.setCursor(this.kag.stat.current_cursor);
    if (this.kag.stat.visible_menu_button == true) {
      $(".button_menu").show();
    } else {
      $(".button_menu").hide();
    }
    $(".event-setting-element").each(function() {
      var nodes = $(this);
      var order_type = nodes.attr("data-event-tag");
      /** @type {*} */
      var restoreScript = JSON.parse(nodes.attr("data-event-pm"));
      var jQuery = object(tyrano.plugin.kag.tag[order_type]);
      jQuery.setEvent(nodes, restoreScript);
    });
    var insert = {
      name : "call",
      pm : {
        storage : "make.ks",
        "auto_next" : cursor
      },
      val : ""
    };
    this.kag.ftag.nextOrderWithIndex(data.current_order_index, data.stat.current_scenario, true, insert, "yes");
  },
  /**
   * @param {?} menu
   * @return {undefined}
   */
  setMenu : function(menu) {
    var that = this;
    var popup = this.kag.layer.getMenuLayer();
    popup.empty();
    /** @type {string} */
    var id = "" + "<div class='menu_item menu_close' style='float:right;'><img src='tyrano/images/kag/menu_button_close.png' /></div>" + "<div style='clear:both'></div>" + "";
    var iframe = $(id);
    popup.append(iframe);
    popup.find(".menu_close").click(function(dataAndEvents) {
      popup.hide();
      if (that.kag.stat.visible_menu_button == true) {
        $(".button_menu").show();
      }
    });
    popup.append(menu);
    popup.show();
  },
  /**
   * @return {undefined}
   */
  hideMenu : function() {
  },
  /**
   * @return {?}
   */
  getSaveData : function() {
    var tmp_array = $.getStorage(this.kag.config.projectID + "_tyrano_data", this.kag.config.configSave);
    if (tmp_array) {
      return eval("(" + tmp_array + ")");
    } else {
      /** @type {Array} */
      tmp_array = new Array;
      var root = {
        kind : "save"
      };
      /** @type {number} */
      var i = 0;
      for (;i < 45;i++) {
        var json = {};
        json.title = $.lang("not_saved");
        /** @type {number} */
        json.current_order_index = 0;
        /** @type {string} */
        json.save_date = "";
        /** @type {string} */
        json.img_data = "";
        json.stat = {};
        json.chapter_name = "";
        tmp_array.push(json);
      }
      /** @type {Array} */
      root.data = tmp_array;
      return root;
    }
  },
  /**
   * @return {undefined}
   */
  displayLog : function() {
    var that = this;
    /** @type {boolean} */
    this.kag.stat.is_skip = false;
    this.kag.html("backlog", {
      "novel" : $.novel
    }, function(env) {
      var v = $(env);
      var tooltip = that.kag.layer.getMenuLayer();
      tooltip.empty();
      tooltip.append(v);
      tooltip.find(".log_body").click(function() {
        tooltip.hide();
        if (that.kag.stat.visible_menu_button == true) {
          $(".button_menu").show();
        }
      });
      /** @type {string} */
      var escaped = "";
      var codeSegments = that.kag.variable.tf.system.backlog;
      /** @type {number} */
      var i = 0;
      for (;i < codeSegments.length;i++) {
        escaped += codeSegments[i] + "<br />";
      }
      var reg = new RegExp("<br /><b>[^<]*</b>\uff1a(" + that.kag.stat.f.main_char_name + ")<br /><b>[^<]*</b>\uff1a", "g");
      escaped = escaped.replace(reg, "$1");
      tooltip.find(".log_body").html(escaped);
      tooltip.show();
      tooltip.find(".log_body").scrollTop(9999999999);
      $(".button_menu").hide();
    });
  },
  /**
   * @return {undefined}
   */
  displayConfig : function() {
    var that = this;
    /** @type {boolean} */
    this.kag.stat.is_skip = false;
    var is_drag = false;
    var config_data = {};
    config_data.already_read_skip = that.kag.config.unReadTextSkip;
    config_data.message_window_type = that.kag.config.messageWindowType;
    config_data.bg_volume = that.kag.config.defaultBgmVolume * 3;
    config_data.se_volume = that.kag.config.defaultSeVolume * 3;
    config_data.ch_speed = (100 - that.kag.config.chSpeed) * 3;
    config_data.auto_speed = (100 - that.kag.config.autoSpeed / 20) * 3;
    config_data.already_speed = (100 - that.kag.config.alreadySpeed) * 3;
    if(this.kag.stat.f.screen_mode == undefined) {
      this.kag.stat.f.screen_mode = 2;
    }
    config_data.screen_mode = this.kag.stat.f.screen_mode;
    this.kag.html("config", {
      "config_data" : config_data,
      "novel" : $.novel
    }, function(env) {
      var v = $(env);
      var tooltip = that.kag.layer.getMenuLayer();
      tooltip.empty();
      tooltip.append(v);
      
      // BGM̉ʐݒ
      tooltip.find(".bar_bgm").bind('touchstart', function() {
        var ratio = 600 / window.innerHeight;
        var pos_x = event.changedTouches[0].pageX;
        var new_pos = parseInt(pos_x * ratio - 20 / ratio);
        var limit_left_pos = parseInt($(".bar_bgm").css("left"));
        var limit_right_pos = limit_left_pos + parseInt($(".bar_bgm").css("width"));
        if(new_pos < limit_left_pos - 20) {
          new_pos = limit_left_pos - 20;
        }
        if(new_pos > limit_right_pos - 20) {
          new_pos = limit_right_pos - 20;
        }
        $(".bgm_value").css("left", new_pos);

        var volume_value = parseInt((new_pos + 20 - parseInt($(this).css("left"))) / 3);
        that.kag.config.defaultBgmVolume = String(volume_value);
        that.kag.evalScript("sf._system_config_bgm_volume = " + volume_value);
        var iterable = that.kag.tmp.map_bgm;
        var amount = parseFloat(volume_value / 100);
        for (key in iterable) {
          iterable[key].setVolume(amount);
        }
      });
      var bgm_value = tooltip.find(".bgm_value");
      bgm_value.bind('touchstart', function() { is_drag = true; });
      bgm_value.bind('touchend', function(e) { is_drag = false; });
      bgm_value.mouseout(function(e) { is_drag = false; });
      bgm_value.bind('touchmove', function(e) {
        if(!is_drag) return;
        var ratio = 600 / window.innerHeight;
        var pos_x = event.changedTouches[0].pageX;
        var new_pos = parseInt(pos_x * ratio - 20 / ratio);
        var limit_left_pos = parseInt($(".bar_bgm").css("left"));
        var limit_right_pos = limit_left_pos + parseInt($(".bar_bgm").css("width"));
        if(new_pos < limit_left_pos - 20) {
          new_pos = limit_left_pos - 20;
        }
        if(new_pos > limit_right_pos - 20) {
          new_pos = limit_right_pos - 20;
        }
        $(".bgm_value").css("left", new_pos);

        var volume_value = parseInt((new_pos + 20 - limit_left_pos) / 3);
        that.kag.config.defaultBgmVolume = String(volume_value);
        that.kag.evalScript("sf._system_config_bgm_volume = " + volume_value);
        var iterable = that.kag.tmp.map_bgm;
        var amount = parseFloat(volume_value / 100);
        for (key in iterable) {
          //iterable[key].volume = amount;
          iterable[key].setVolume(amount);
        }
      });
      // SẺʐݒ
      tooltip.find(".bar_se").bind('touchstart', function() {
        var ratio = 600 / window.innerHeight;
        var pos_x = event.changedTouches[0].pageX;
        var new_pos = parseInt(pos_x * ratio - 20 / ratio);
        var limit_left_pos = parseInt($(".bar_se").css("left"));
        var limit_right_pos = limit_left_pos + parseInt($(".bar_se").css("width"));
        if(new_pos < limit_left_pos - 20) {
          new_pos = limit_left_pos - 20;
        }
        if(new_pos > limit_right_pos - 20) {
          new_pos = limit_right_pos - 20;
        }
        $(".se_value").css("left", new_pos);

        var volume_value = parseInt((new_pos + 20 - parseInt($(this).css("left"))) / 3);
        that.kag.config.defaultSeVolume = String(volume_value);
        that.kag.evalScript("sf._system_config_se_volume = " + volume_value);
        var iterable = that.kag.tmp.map_se;
        var amount = parseFloat(volume_value / 100);
        for (key in iterable) {
          iterable[key].volume = amount;
        }
      });
      var se_value = tooltip.find(".se_value");
      se_value.bind('touchstart', function() { is_drag = true; });
      se_value.bind('touchend', function(e) { is_drag = false; });
      se_value.mouseout(function(e) { is_drag = false; });
      se_value.bind('touchmove', function(e) {
        if(!is_drag) return;
        var ratio = 600 / window.innerHeight;
        var pos_x = event.changedTouches[0].pageX;
        var new_pos = parseInt(pos_x * ratio - 20 / ratio);
        var limit_left_pos = parseInt($(".bar_se").css("left"));
        var limit_right_pos = limit_left_pos + parseInt($(".bar_se").css("width"));
        if(new_pos < limit_left_pos - 20) {
          new_pos = limit_left_pos - 20;
        }
        if(new_pos > limit_right_pos - 20) {
          new_pos = limit_right_pos - 20;
        }
        $(".se_value").css("left", new_pos);

        var volume_value = parseInt((new_pos + 20 - limit_left_pos) / 3);
        that.kag.config.defaultSeVolume = String(volume_value);
        that.kag.evalScript("sf._system_config_se_volume = " + volume_value);
        var iterable = that.kag.tmp.map_se;
        var amount = parseFloat(volume_value / 100);
        for (key in iterable) {
          iterable[key].volume = amount;
        }
      });
      // eLXg̑xݒ
      tooltip.find(".bar_ch_speed").bind('touchstart', function() {
        var ratio = 600 / window.innerHeight;
        var pos_x = event.changedTouches[0].pageX;
        var new_pos = parseInt(pos_x * ratio - 20 / ratio);
        var limit_left_pos = parseInt($(".bar_ch_speed").css("left"));
        var limit_right_pos = limit_left_pos + parseInt($(".bar_ch_speed").css("width"));
        if(new_pos < limit_left_pos - 20) {
          new_pos = limit_left_pos - 20;
        }
        if(new_pos > limit_right_pos - 20) {
          new_pos = limit_right_pos - 20;
        }
        $(".ch_speed_value").css("left", new_pos);

        var volume_value = 100 - parseInt((new_pos + 20 - parseInt($(this).css("left"))) / 3);
        that.kag.config.chSpeed = volume_value;
        that.kag.evalScript("sf._config_ch_speed = " + volume_value);
      });
      var ch_speed_value = tooltip.find(".ch_speed_value");
      ch_speed_value.bind('touchstart', function() { is_drag = true; });
      ch_speed_value.bind('touchend', function(e) { is_drag = false; });
      ch_speed_value.mouseout(function(e) { is_drag = false; });
      ch_speed_value.bind('touchmove', function(e) {
        if(!is_drag) return;
        var ratio = 600 / window.innerHeight;
        var pos_x = event.changedTouches[0].pageX;
        var new_pos = parseInt(pos_x * ratio - 20 / ratio);
        var limit_left_pos = parseInt($(".bar_ch_speed").css("left"));
        var limit_right_pos = limit_left_pos + parseInt($(".bar_ch_speed").css("width"));
        if(new_pos < limit_left_pos - 20) {
          new_pos = limit_left_pos - 20;
        }
        if(new_pos > limit_right_pos - 20) {
          new_pos = limit_right_pos - 20;
        }
        $(".ch_speed_value").css("left", new_pos);

        var volume_value = 100 - parseInt((new_pos + 20 - limit_left_pos) / 3);
        that.kag.config.chSpeed = volume_value;
        that.kag.evalScript("sf._config_ch_speed = " + volume_value);
      });
      // I[g̃eLXg̑xݒ
      tooltip.find(".bar_auto_speed").bind('touchstart', function() {
        var ratio = 600 / window.innerHeight;
        var pos_x = event.changedTouches[0].pageX;
        var new_pos = parseInt(pos_x * ratio - 20 / ratio);
        var limit_left_pos = parseInt($(".bar_auto_speed").css("left"));
        var limit_right_pos = limit_left_pos + parseInt($(".bar_auto_speed").css("width"));
        if(new_pos < limit_left_pos - 20) {
          new_pos = limit_left_pos - 20;
        }
        if(new_pos > limit_right_pos - 20) {
          new_pos = limit_right_pos - 20;
        }
        $(".auto_speed_value").css("left", new_pos);

        var volume_value = (100 - parseInt((new_pos + 20 - parseInt($(this).css("left"))) / 3)) * 20;
        that.kag.config.autoSpeed = volume_value;
        that.kag.evalScript("sf._system_config_auto_speed = " + volume_value);
      });
      var auto_speed_value = tooltip.find(".auto_speed_value");
      auto_speed_value.bind('touchstart', function() { is_drag = true; });
      auto_speed_value.bind('touchend', function(e) { is_drag = false; });
      auto_speed_value.mouseout(function(e) { is_drag = false; });
      auto_speed_value.bind('touchmove', function(e) {
        if(!is_drag) return;
        var ratio = 600 / window.innerHeight;
        var pos_x = event.changedTouches[0].pageX;
        var new_pos = parseInt(pos_x * ratio - 20 / ratio);
        var limit_left_pos = parseInt($(".bar_auto_speed").css("left"));
        var limit_right_pos = limit_left_pos + parseInt($(".bar_auto_speed").css("width"));
        if(new_pos < limit_left_pos - 20) {
          new_pos = limit_left_pos - 20;
        }
        if(new_pos > limit_right_pos - 20) {
          new_pos = limit_right_pos - 20;
        }
        $(".auto_speed_value").css("left", new_pos);

        var volume_value = (100 - parseInt((new_pos + 20 - limit_left_pos) / 3)) * 20;
        that.kag.config.autoSpeed = volume_value;
        that.kag.evalScript("sf._system_config_auto_speed = " + volume_value);
      });
      // ǎ̃eLXg̑xݒ
      tooltip.find(".bar_already_speed").bind('touchstart', function() {
        var ratio = 600 / window.innerHeight;
        var pos_x = event.changedTouches[0].pageX;
        var new_pos = parseInt(pos_x * ratio - 20 / ratio);
        var limit_left_pos = parseInt($(".bar_already_speed").css("left"));
        var limit_right_pos = limit_left_pos + parseInt($(".bar_already_speed").css("width"));
        if(new_pos < limit_left_pos - 20) {
          new_pos = limit_left_pos - 20;
        }
        if(new_pos > limit_right_pos - 20) {
          new_pos = limit_right_pos - 20;
        }
        $(".already_speed_value").css("left", new_pos);

        var volume_value = 100 - parseInt((new_pos + 20 - parseInt($(this).css("left"))) / 3);
        that.kag.config.alreadySpeed = volume_value;
        that.kag.evalScript("sf._config_already_speed = " + volume_value);
      });
      var already_speed_value = tooltip.find(".already_speed_value");
      already_speed_value.bind('touchstart', function() { is_drag = true; });
      already_speed_value.bind('touchend', function(e) { is_drag = false; });
      already_speed_value.mouseout(function(e) { is_drag = false; });
      already_speed_value.bind('touchmove', function(e) {
        if(!is_drag) return;
        var ratio = 600 / window.innerHeight;
        var pos_x = event.changedTouches[0].pageX;
        var new_pos = parseInt(pos_x * ratio - 20 / ratio);
        var limit_left_pos = parseInt($(".bar_already_speed").css("left"));
        var limit_right_pos = limit_left_pos + parseInt($(".bar_already_speed").css("width"));
        if(new_pos < limit_left_pos - 20) {
          new_pos = limit_left_pos - 20;
        }
        if(new_pos > limit_right_pos - 20) {
          new_pos = limit_right_pos - 20;
        }
        $(".already_speed_value").css("left", new_pos);

        var volume_value = 100 - parseInt((new_pos + 20 - limit_left_pos) / 3);
        that.kag.config.alreadySpeed = volume_value;
        that.kag.evalScript("sf._config_already_speed = " + volume_value);
      });
      // XN[̐ݒ
      tooltip.find(".screen_mode_full").click(function() {
        if(that.kag.stat.f.screen_mode == 1) {
          return;
        }
        that.kag.stat.f.screen_mode = 1;
        $(".screen_mode_full").find("img").attr("src","tyrano/images/kag/botan_on.png");
        $(".screen_mode_window").find("img").attr("src","tyrano/images/kag/botan_off.png");
        that.screenFull();
      });
      tooltip.find(".screen_mode_window").click(function() {
        if(that.kag.stat.f.screen_mode == 2) {
          return;
        }
        that.kag.stat.f.screen_mode = 2;
        $(".screen_mode_full").find("img").attr("src","tyrano/images/kag/botan_off.png");
        $(".screen_mode_window").find("img").attr("src","tyrano/images/kag/botan_on.png");
        that.screenFull();
      });
      // ǃXLbv̐ݒ
      tooltip.find(".already_read_skip").click(function() {
        if(that.kag.config.unReadTextSkip == true) {
          $(".already_read_skip").find("img").attr("src","tyrano/images/kag/botan_on.png");
          that.kag.config.unReadTextSkip = false;
          that.kag.evalScript("sf._system_config_unread_text_skip = false");
        } else {
          $(".already_read_skip").find("img").attr("src","tyrano/images/kag/botan_off.png");
          that.kag.config.unReadTextSkip = true;
          that.kag.evalScript("sf._system_config_unread_text_skip = true");
        }
      });
      // bZ[WEBhEg̐ݒ
      tooltip.find(".message_window_type").each(function() {
        $(this).click(function(dataAndEvents) {
          var _i = $(this).attr("num");
          that.kag.config.messageWindowType = _i;
          that.kag.evalScript("sf.message_window_type = " + _i);
          var msg = that.kag.getMessageOuterLayer();
          msg.css("background-image", "url(./data/image/frame" + _i + ".png)");
          tooltip.find(".message_window_type").each(function() {
            if(_i == $(this).attr("num")) {
              $(this).find("img").attr("src","tyrano/images/kag/botan_on.png");
            } else {
              $(this).find("img").attr("src","tyrano/images/kag/botan_off.png");
            }
          });
        });
      });
      // {^
      tooltip.find(".menu_close").click(function() {
        tooltip.hide();
        if (that.kag.stat.visible_menu_button == true) {
          $(".button_menu").show();
        }
      });
      tooltip.show();
      $(".button_menu").hide();
    });
  },
  /**
   * @return {undefined}
   */
  displayExit : function() {
    var that = this;
    /** @type {boolean} */
    this.kag.stat.is_skip = false;
    this.kag.html("exit", {
      "novel" : $.novel
    }, function(env) {
      var v = $(env);
      var tooltip = that.kag.layer.getMenuLayer();
      tooltip.empty();
      tooltip.append(v);
      tooltip.find(".confirm_yes").click(function() {
        window.close();
        if (typeof navigator.app != "undefined") {
          navigator.app.exitApp();
        }
        if (typeof require != "undefined" && typeof require("nw.gui") != "undefined") {
          require("nw.gui").Window.get().close();
        }
      });
      tooltip.find(".confirm_no").click(function() {
        tooltip.hide();
        if (that.kag.stat.visible_menu_button == true) {
          $(".button_menu").show();
        }
      });
      $(".button_menu").hide();
    });
  },
  /**
   * @return {undefined}
   */
  screenFull : function() {
    if ($.userenv() == "pc") {
      var gui = require("nw.gui");
      var that = gui.Window.get();
      if (that.isFullscreen) {
        that.leaveFullscreen();
      } else {
        that.enterFullscreen();
      }
    }
  },
  /**
   * @return {undefined}
   */
  test : function() {
  }
};
